' Register FxCop 10 as an external tool in Visual Studio 2010 (http://idlebit.es)
Option Explicit
Dim AppName, FolderApp, strRoot, objShell, NumKey, Result

' Init default values and Shell object
Function Init ()
	AppName   = "Microsoft FxCop 10.0"
	FolderApp = "%programfiles%\" & AppName
	strRoot   = "HKEY_CURRENT_USER\Software\Microsoft\VisualStudio\10.0\External Tools\" 
  On Error Resume Next
	Set objShell = CreateObject("WScript.Shell") 
	NumKey = objShell.RegRead(strRoot & "ToolNumKeys") 
	Init = err.number = 0
End Function

' Return status code (0=OK, 1=Already installed)
Function RegisterExternalTool ()
  If Not ExistExternalTool Then
    Call AddExternalTool
    RegisterExternalTool = 0
  Else 
    RegisterExternalTool = 1
  End If
End Function

' Check whether it is already registered
Function ExistExternalTool()
	Dim i, title
	For i = 0 To NumKey - 1
		title = objShell.RegRead(strRoot & "ToolTitle" & i)
		If title = AppName Then
			ExistExternalTool = True
			Exit Function
		End If
	Next
End Function

' Add registry values
Sub AddExternalTool ()
  objShell.RegWrite strRoot & "ToolTitle" & NumKey, AppName, "REG_SZ"
  objShell.RegWrite strRoot & "ToolCmd" & NumKey, FolderApp & "\FxCopCmd.exe", "REG_SZ"
  objShell.RegWrite strRoot & "ToolArg" & NumKey, "/c /f:$(TargetPath) /d:$(BinDir) /r:""" & FolderApp & "\Rules""" , "REG_SZ"
  objShell.RegWrite strRoot & "ToolDir" & NumKey, FolderApp & """", "REG_SZ"
  objShell.RegWrite strRoot & "ToolSourceKey" & NumKey, "", "REG_SZ"
  objShell.RegWrite strRoot & "ToolOpt" & NumKey, 26, "REG_DWORD"
  objShell.RegWrite strRoot & "ToolNumKeys", NumKey + 1, "REG_DWORD"
End Sub

If Init Then 
	Result = RegisterExternalTool
	Select Case Result
    Case 0:
      MsgBox AppName & " added as an external tool. Enjoy it!", 64, AppName
    Case 1:
      MsgBox AppName & " is already registered as an external tool.", 48, AppName
	End Select
Else
	MsgBox "Visual Studio 2010 is not installed on this machine.", 16, AppName
End If
